SystemOrganization addCategory: #'HelpSystem-Core-Model'!
SystemOrganization addCategory: #'HelpSystem-Core-Utilities'!
SystemOrganization addCategory: #'HelpSystem-Core-UI'!
SystemOrganization addCategory: #'HelpSystem-Core-Help'!

PluggableListItemWrapper subclass: #HelpTopicListItemWrapper
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-UI'!

!HelpTopicListItemWrapper methodsFor: 'accessing' stamp: 'tbn 2/19/2010 15:47'!
asString
	^item title! !

!HelpTopicListItemWrapper methodsFor: 'accessing' stamp: 'tbn 2/19/2010 15:48'!
balloonText
	^self item title! !

!HelpTopicListItemWrapper methodsFor: 'accessing' stamp: 'tbn 2/12/2010 13:59'!
contents
 	item isPage ifTrue: [^#()].	
	^(item rootTopics) collect: [ :each | 
		HelpTopicListItemWrapper with: each
	].
! !

!HelpTopicListItemWrapper methodsFor: 'accessing' stamp: 'tbn 2/12/2010 16:51'!
highlightingColor

	^Color blue  ! !

!HelpTopicListItemWrapper methodsFor: 'accessing' stamp: 'tbn 2/12/2010 14:16'!
icon
	item isBook ifTrue: [^HelpIcons iconNamed: #bookIcon].
	^HelpIcons iconNamed: #pageIcon! !

Object subclass: #CustomHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!CustomHelp class methodsFor: 'accessing' stamp: 'tbn 2/19/2010 13:57'!
bookName
	^self subclassResponsibility ! !

!CustomHelp class methodsFor: 'accessing' stamp: 'DannyChan 2/22/2010 19:29'!
pages
	<help>
	"Return a list of selectors for methods that return a HelpPage."
	^#()! !

CustomHelp subclass: #HelpIntroduction
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Help'!

!HelpIntroduction commentStamp: 'tbn 2/12/2010 14:27' prior: 0!
Welcome to Pharo Smalltalk Help System!

HelpIntroduction subclass: #HelpApiDoc
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Help'!

!HelpApiDoc class methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 11:18'!
bookName
	^'HelpSystem API Documentation'! !

!HelpApiDoc class methodsFor: 'pages' stamp: 'DannyChan 2/20/2010 16:40'!
coreModel
	^PackageAPIHelpBook on: 'HelpSystem-Core-Model'! !

!HelpApiDoc class methodsFor: 'pages' stamp: 'DannyChan 2/20/2010 16:33'!
coreUI
	^PackageAPIHelpBook on: 'HelpSystem-Core-UI'! !

!HelpApiDoc class methodsFor: 'pages' stamp: 'DannyChan 2/20/2010 16:33'!
coreUtilities
	^PackageAPIHelpBook on: 'HelpSystem-Core-Utilities'! !

!HelpApiDoc class methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 16:40'!
pages
	^#(#coreModel coreUtilities coreUI)! !

HelpIntroduction subclass: #HelpHowTo
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Help'!

!HelpHowTo class methodsFor: 'accessing' stamp: 'tbn 2/12/2010 23:07'!
bookName
	^'How to build a custom help'! !

!HelpHowTo class methodsFor: 'pages' stamp: 'tbn 2/19/2010 15:41'!
overview
	^HelpPage
		title: 'Overview'
		contents:	
	'OVERVIEW
	
The help system allows you to add own books and help texts. You can either do this programmatically by adding HelpBook instances to the default HelpSystem instance. 
	
	A much more convenient and reproducable way is to implement custom help classes. This allows you to implement and manage your help texts using the standard development and code management tools.'! !

!HelpHowTo class methodsFor: 'accessing' stamp: 'tbn 2/12/2010 23:57'!
pages
	^#(overview step1 step2 step3 step4 step5)! !

!HelpHowTo class methodsFor: 'pages' stamp: 'tbn 2/19/2010 15:41'!
step1
	^HelpPage
		title: 'Step 1 - Create a class for the book'
		contents:
		'STEP 1 - CREATE A CLASS FOR THE BOOK
		
There is a predefined class CustomHelp which you have to subclass for a custom help book to show up as a book in the Help browser:
	
  CustomHelp subclass: #MyAppHelp
    	instanceVariableNames: ''''
	  classVariableNames: ''''
	  poolDictionaries: ''''
	  category: ''MyApp-Help'' 

Class methods on this class can reflect pages and if you want to provide nested help books just subclass your own help class to form a hierarchy. Any new subclass of MyAppHelp will then be a new book in your hierarchy.

The class category used should end with "-Help" so it is easy to recognize that it includes the help support of your project.'
! !

!HelpHowTo class methodsFor: 'pages' stamp: 'tbn 2/19/2010 15:41'!
step2
	^HelpPage
		title: 'Step 2 - Provide a book name'
		contents:
	'STEP 2 - PROVIDE A BOOK NAME
	
Now implement the class method #bookName to return the name of your help book.

   bookName
	    ^''My App help''
	
By implementing this method the system knows how you would like to name your book and uses the given string as a label in the HelpBrowser later.'
! !

!HelpHowTo class methodsFor: 'pages' stamp: 'DannyChan 2/20/2010 19:36'!
step3
	^HelpPage
		title: 'Step 3 - Implement pages using methods'
		contents:
	'STEP 3 - IMPLEMENT PAGES USING METHODS 

Implement a page by defining a method that returns an instance of HelpPage defining a page title and a help text displayed in the help browser. 

     firstPage
     	    ^HelpPage
	           title: ''First Page'' 
              text: ''Hello world''

Define a new method for each page of your book. Please group the pages in a method category called "pages".

Instead of returning a HelpPage instance you can also return a DynamicHelpPage instance, which can create the contents and sub books dynamically, for example:

firstPage
	^DynamicHelpPage 
		titleBlock: [Object asString]
       contentBlock: [Object comment]
		rootTopicsBlock: [#()]

Note: 
=====
Later we may add support for better help contents than just plain text (markup descriptions, active morphs, ...) by subclassing HelpPage.'
! !

!HelpHowTo class methodsFor: 'pages' stamp: 'tbn 2/19/2010 15:41'!
step4
	^HelpPage
		title: 'Step 4 - Defining the page order'
		contents:
	'STEP 4 - DEFINING THE PAGE ORDER 

By implementing the class method #pages you return a collection of method selectors to define the order in which the pages appear in your book: 

     pages
     	    ^#(firstPage secondPage)

'
! !

!HelpHowTo class methodsFor: 'pages' stamp: 'tbn 2/19/2010 15:41'!
step5
	^HelpPage
		title: 'Step 5 - Test your help'
		contents:
	'STEP 5 - TEST YOUR HELP
	
By using 
	
       HelpSystem reset.
       HelpBrowser open

you can reset the help system. This forces the system to rebuild the root books together with all help topics and include your new help definition. 
'
! !

!HelpIntroduction class methodsFor: 'accessing' stamp: 'tbn 2/19/2010 14:21'!
bookName
	^'Help on Help'! !

!HelpIntroduction class methodsFor: 'pages' stamp: 'tbn 2/19/2010 15:41'!
implementation
	^HelpPage 
		title: 'Implementation'
		contents:	
	'THE IMPLEMENTATION

The help system typically consists of help books including one or more topics (pages or other help books). This simple model is reflected in the two classes HelpTopic and HelpBook. 

Since this model forms a hierarchical structure of help items there is a browser to display the help contents. This browser is implemented in class HelpBrowser.

To globally access the systems default help contents there is a class HelpSystem. Just inspect ''HelpSystem default'' to see it''s current contents or access the books at the top of the hierarchy using ''HelpSystem default rootItems''.
'! !

!HelpIntroduction class methodsFor: 'pages' stamp: 'tbn 2/19/2010 15:41'!
introduction
	^HelpPage 
		title: 'Introduction'
		contents: 
	'WELCOME TO THE HELP SYSTEM

The Pharo help system is a simple user interface to display help contents to the user. It can be accessed from the world menu using "Tools" -> "Help Browser" or by evaluating ''HelpBrowser open'' in a workspace.

The help contents is stored as source code using annotated methods in specific help provider classes. This allows to manage the help texts using the standard development tools.
'! !

!HelpIntroduction class methodsFor: 'accessing' stamp: 'tbn 2/19/2010 13:44'!
pages
	^#(introduction implementation)! !

Object subclass: #HelpBrowser
	instanceVariableNames: 'window textMorph text'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-UI'!

!HelpBrowser class methodsFor: 'class initialization' stamp: 'tbn 2/12/2010 12:17'!
initialize
	"Initializes the receiver class"
	TheWorldMenu registerOpenCommand: {'Help Browser'. {self. #open}}.

	self open! !

!HelpBrowser class methodsFor: 'instance creation' stamp: 'tbn 2/12/2010 11:45'!
open
	^(self new)
		open;
		yourself! !

!HelpBrowser methodsFor: 'ui' stamp: 'tbn 2/12/2010 12:57'!
close
	window notNil ifTrue: [window delete]! !

!HelpBrowser methodsFor: 'initialize-release' stamp: 'tbn 2/12/2010 15:32'!
initWindow
	| treeMorph items   |
	window := SystemWindow labelled: 'Help Browser'.
	"Tree"
	treeMorph := PluggableTreeMorph new.
	items := HelpSystem default rootTopics collect: [:each | HelpTopicListItemWrapper with: each ].
	treeMorph list: items; model: self; setSelectedSelector: #onItemClicked:.
	window addMorph: treeMorph frame: (0@0 corner: 0.3@1).
	
	"Text"
	text := PluggableTextMorph on: self 
			text: nil accept: nil
			readSelection: nil menu: nil.
	window addMorph: text frame: (0.3@0 corner: 1@1).		
			
			! !

!HelpBrowser methodsFor: 'initialize-release' stamp: 'tbn 2/12/2010 13:01'!
initialize 
	super initialize.
	self initWindow.
 ! !

!HelpBrowser methodsFor: 'events' stamp: 'DannyChan 2/20/2010 17:53'!
onItemClicked: anItem
	anItem isNil ifTrue: [^text setText: ''].
	text setText: anItem contents! !

!HelpBrowser methodsFor: 'ui' stamp: 'tbn 2/12/2010 12:58'!
open	
 	"Open the receivers window" 
		
	window openInWorld.! !

Object subclass: #HelpBuilder
	instanceVariableNames: 'rootTopics rootToBuildFrom'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Utilities'!

!HelpBuilder commentStamp: 'tbn 2/12/2010 14:54' prior: 0!
This is an utility class that builds the books for a help system.

Instance Variables
	rootTopics:		<OrderedCollection>

rootTopics
	- a collection of books 
!

!HelpBuilder class methodsFor: 'instance creation' stamp: 'tbn 2/12/2010 14:42'!
build
	^(self new)
		build;
		yourself! !

!HelpBuilder class methodsFor: 'instance creation' stamp: 'tbn 2/12/2010 15:01'!
buildFromRoot: aDescription
	"Start building from the given root class"
	
	^(self new)
		rootToBuildFrom: aDescription;
		build;
		yourself! !

!HelpBuilder methodsFor: 'building' stamp: 'tbn 2/19/2010 15:36'!
build
	"Start building a help system from code"
	|helpOnHelp|
 
	self rootToBuildFrom subclasses do: [:each |
		each = HelpIntroduction ifFalse: [ 
			rootTopics add: (self createBookFrom: each)
		].		
	].
 	rootTopics add: (self createBookFrom: HelpIntroduction)
! !

!HelpBuilder methodsFor: 'private building' stamp: 'tbn 2/19/2010 15:47'!
createBookFrom: aDescription
	|book page method pragma   |
	book := HelpBook named: aDescription bookName.	
	aDescription pages do: [:pageSelector|
		page := aDescription perform: pageSelector.	 
		book addTopic: page.
	].	
	aDescription subclasses do: [:subclass |
				book addTopic: (self createBookFrom: subclass)	].
	^book! !

!HelpBuilder methodsFor: 'defaults' stamp: 'tbn 2/12/2010 14:59'!
defaultRoot
	"Defines the root hierarchy, can be overwritten in own builders"
 
	^CustomHelp  ! !

!HelpBuilder methodsFor: 'initialize-release' stamp: 'tbn 2/12/2010 14:52'!
initialize 
	"Initializes the receiver"
	
	super initialize.
	rootTopics := OrderedCollection new.
	rootToBuildFrom := self defaultRoot! !

!HelpBuilder methodsFor: 'accessing' stamp: 'tbn 2/12/2010 14:53'!
rootToBuildFrom
	^ rootToBuildFrom! !

!HelpBuilder methodsFor: 'accessing' stamp: 'tbn 2/12/2010 14:53'!
rootToBuildFrom: anObject
	rootToBuildFrom := anObject! !

!HelpBuilder methodsFor: 'accessing' stamp: 'tbn 2/12/2010 14:53'!
rootTopics
	^ rootTopics! !

Object subclass: #HelpIcons
	instanceVariableNames: ''
	classVariableNames: 'Icons'
	poolDictionaries: ''
	category: 'HelpSystem-Core-UI'!

!HelpIcons class methodsFor: 'private' stamp: 'tbn 2/12/2010 14:17'!
bookIcon
	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 0 0 0 0 284817913 552924404 0 0 0 0 0 0 0 0 0 817149108 3747766882 4287730065 2679749049 549766340 0 0 0 0 0 0 1086110908 4016202338 4287137928 4288914339 4288914339 4289111718 3216290996 1086505666 0 0 0 816754350 4014952271 4287137928 4289309097 4289769648 4289111718 4288453788 4288453788 4288453788 2947658161 0 814846353 4283782485 4287072135 4288059030 4288059030 4288387995 4289243304 4289309097 4287927444 4287598479 2411050421 1081900156 4283585106 4286611584 4287532686 4287532686 4287466893 4287466893 4287401100 4287401100 4287401100 4288716960 2946868645 3211290728 4288651167 4287269514 4287006342 4287006342 4287006342 4286940549 4286940549 4287203721 4289177511 3483213213 281725642 2677183122 4293190884 4292861919 4289177511 4286874756 4286611584 4286611584 4287006342 4289638062 4020084125 549042617 0 282054607 2677643673 4289572269 4293256677 4292796126 4288980132 4287137928 4290164406 4020215711 816754350 0 0 0 0 551082200 2677643673 4289572269 4293256677 4292401368 4289177511 1085584564 0 0 0 0 0 0 0 551213786 2677643673 4288651167 1623244992 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0 0)
	offset: 0@0)! !

!HelpIcons class methodsFor: 'accessing' stamp: 'tbn 2/12/2010 15:54'!
iconNamed: aSymbol

	^self icons at: aSymbol ifAbsentPut: [self perform: aSymbol]! !

!HelpIcons class methodsFor: 'accessing' stamp: 'tbn 2/12/2010 15:55'!
icons
	Icons isNil ifTrue: [Icons := Dictionary new].
	^Icons! !

!HelpIcons class methodsFor: 'private' stamp: 'tbn 2/12/2010 14:18'!
pageIcon
	^(Form
	extent: 12@12
	depth: 32
	fromArray: #( 0 221196079 1366981242 1366915449 1366915449 1366849656 1366783863 1128876361 33554432 0 0 0 0 726552142 4294309365 4294243572 4294111986 4294046193 4293914607 4292861919 2843705215 319885585 0 0 0 726551886 4294177779 4294111986 4293980400 4293914607 4293848814 4293717228 4292138196 3734147730 269619730 0 0 726486349 4294046193 4293980400 4293914607 4293783021 4293717228 4293585642 4293454056 4291085508 639705377 0 0 726420557 4293980400 4293848814 4293783021 4293651435 4293585642 4293519849 4293388263 4292993505 640034342 0 0 726420556 4293848814 4293717228 4293651435 4293585642 4293454056 4293388263 4293256677 4293190884 623322919 0 0 726354764 4293717228 4293651435 4293519849 4293454056 4293322470 4293256677 4293125091 4293059298 623257126 0 0 726354507 4293585642 4293519849 4293388263 4293322470 4293190884 4293125091 4293059298 4292993505 623191333 0 0 726288970 4293454056 4293388263 4293256677 4293190884 4293125091 4292993505 4292993505 4292993505 623191333 0 0 726223178 4293322470 4293256677 4293190884 4293059298 4292993505 4292993505 4292993505 4292993505 623191333 0 0 726223177 4293256677 4293125091 4293059298 4292993505 4292993505 4292993505 4292993505 4292993505 623191333 0 0 490092087 3080033685 3079967892 3079967892 3079967892 3079967892 3079967892 3079967892 3079967892 454629657 0)
	offset: 0@0)! !

Object subclass: #HelpSystem
	instanceVariableNames: 'rootTopics'
	classVariableNames: 'Default'
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!HelpSystem class methodsFor: 'accessing' stamp: 'tbn 2/12/2010 13:55'!
default
	"Default := nil"
	Default isNil ifTrue: [Default := self initDefault].
	^Default! !

!HelpSystem class methodsFor: 'class initialization' stamp: 'tbn 2/12/2010 15:20'!
initDefault	
	|helpSystem builder|
	helpSystem := self new.
	builder := HelpBuilder build.
	builder rootTopics do: [:each |
		helpSystem addRootTopic: each.	
	].
	^helpSystem ! !

!HelpSystem class methodsFor: 'class initialization' stamp: 'tbn 2/12/2010 15:20'!
reset
	Default := nil! !

!HelpSystem methodsFor: 'accessing' stamp: 'tbn 2/12/2010 12:51'!
addRootTopic: aTopic

	self rootTopics add: aTopic.! !

!HelpSystem methodsFor: 'initialize-release' stamp: 'tbn 2/12/2010 12:53'!
initialize 
	super initialize.
	rootTopics := OrderedCollection new! !

!HelpSystem methodsFor: 'accessing' stamp: 'tbn 2/12/2010 12:51'!
rootTopics

	 ^rootTopics ! !

Object subclass: #HelpTopic
	instanceVariableNames: 'title key contents'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

HelpTopic subclass: #DynamicHelpPage
	instanceVariableNames: 'titleBlock contentsBlock rootTopicsBlock'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!DynamicHelpPage commentStamp: 'DannyChan 2/20/2010 17:58' prior: 0!
A DynamicHelpBook creates its sub topics dynamically. It is initialized with block closures that are executed on demand to create the contents and the sub topics.!

DynamicHelpPage subclass: #ClassAPIHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!ClassAPIHelp commentStamp: 'DannyChan 2/20/2010 17:59' prior: 0!
A ClassAPIHelp creates the API documentation for a class dynamically.!

!ClassAPIHelp class methodsFor: 'help' stamp: 'DannyChan 2/20/2010 17:55'!
classDoc: aClass
	| text comments methodComment |
	^'Class Comment: ' 
	  	, Character cr asString , Character cr asString 
		, aClass comment
! !

!ClassAPIHelp class methodsFor: 'instance creation' stamp: 'DannyChan 2/20/2010 17:21'!
on: aClass
	^ self
		titleBlock: [ 'Class ' , aClass asString ]
		contentsBlock: [ self classDoc: aClass ]
		rootTopicsBlock: [ {MethodListHelp onInstanceSideOf: aClass
								. MethodListHelp onClassSideOf: aClass} ]! !

!ClassAPIHelp methodsFor: 'testing' stamp: 'DannyChan 2/20/2010 17:55'!
isBook
	^self isPage not! !

!ClassAPIHelp methodsFor: 'testing' stamp: 'DannyChan 2/20/2010 17:20'!
isPage
	^false! !

!DynamicHelpPage class methodsFor: 'instance creation' stamp: 'DannyChan 2/20/2010 17:58'!
titleBlock: aTitleBlock contentsBlock: aContentsBlock rootTopicsBlock: aRootTopicsBlock
	"Create a new instance with blocks to create the title, the contents, and the root topics"
	^(self new)
		titleBlock: aTitleBlock;
		contentsBlock: aContentsBlock;
		rootTopicsBlock: aRootTopicsBlock;
		yourself.! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 10:37'!
contents 
	^contentsBlock value.! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 10:28'!
contentsBlock
	^contentsBlock ifNil: [contentsBlock := ['Not implemented']].! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 10:27'!
contentsBlock: anObject
	contentsBlock := anObject! !

!DynamicHelpPage methodsFor: 'defaults' stamp: 'DannyChan 2/20/2010 10:35'!
defaultTitle
	^'A Dynamic Help Page'! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 09:14'!
rootTopics
	^rootTopicsBlock value.! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 09:17'!
rootTopicsBlock
	^rootTopicsBlock ifNil: [rootTopicsBlock := [#()]].! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 09:17'!
rootTopicsBlock: aBlock
	rootTopicsBlock := aBlock.! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 10:37'!
title
	^titleBlock value.! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 10:28'!
titleBlock
	^titleBlock ifNil: [titleBlock := ['Not implemented']].! !

!DynamicHelpPage methodsFor: 'accessing' stamp: 'DannyChan 2/20/2010 10:27'!
titleBlock: anObject
	titleBlock := anObject! !

DynamicHelpPage subclass: #MethodListHelp
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!MethodListHelp commentStamp: 'DannyChan 2/20/2010 18:01' prior: 0!
A MethodListHelp creates help content for the methods of a class. Use the #onClassSideOf: or #onInstanceSideOf: messages to create new instances for the class methods or the instance methods of a class object.!

!MethodListHelp class methodsFor: 'private' stamp: 'DannyChan 2/22/2010 07:53'!
addCommentFrom: aClass at: selector to: text
	| comments methodComment |
	comments := aClass commentsAt: selector.
	comments size = 0
		ifTrue: [ methodComment := 'Method has no comment.' ]
		ifFalse: [ methodComment := comments at: 1 ].
	^text , selector asString , Character cr asString , methodComment , Character cr asString , Character cr asString
		, '###' , Character cr asString , Character cr asString! !

!MethodListHelp class methodsFor: 'private' stamp: 'DannyChan 2/22/2010 19:32'!
hasHelp: aClass at: selector
	| method |
	method := aClass methodDict at: selector.
	^(method pragmas detect: [ :each | each keyword = #public ] ifNone: []) isNil 
		and: [method pragmas size > 0]! !

!MethodListHelp class methodsFor: 'private' stamp: 'DannyChan 2/22/2010 19:27'!
methodDocs: aClass
	| important other method |
	important := 'Important Methods' , Character cr asString , Character cr asString.
	other := '----------------' , Character cr asString , Character cr asString , 'Other Methods' , Character cr asString
		, Character cr asString.
	aClass selectors
		do:
			[ :selector | 
			(self hasHelp: aClass at: selector)
				ifTrue: [ important := self
								addCommentFrom: aClass
								at: selector
								to: important ]
				ifFalse: [ other := self
								addCommentFrom: aClass
								at: selector
								to: other ].
			] .
	^ important , other! !

!MethodListHelp class methodsFor: 'private' stamp: 'DannyChan 2/20/2010 17:15'!
on: anObject forInstanceSide: forInstanceSide
	| title |
	forInstanceSide 
		ifTrue: [title := 'Instance Side']
		ifFalse: [title := 'Class Side'].
	^ self
		titleBlock: [title]
		contentsBlock: [ self methodDocs: anObject ]
		rootTopicsBlock: [#()]. ! !

!MethodListHelp class methodsFor: 'instance creation' stamp: 'DannyChan 2/20/2010 17:16'!
onClassSideOf: aClass
	^self on: aClass class forInstanceSide: false! !

!MethodListHelp class methodsFor: 'instance creation' stamp: 'DannyChan 2/20/2010 17:16'!
onInstanceSideOf: aClass
	^self on: aClass forInstanceSide: true! !

DynamicHelpPage subclass: #PackageAPIHelpBook
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!PackageAPIHelpBook commentStamp: 'DannyChan 2/20/2010 09:29' prior: 0!
A PackageAPIHelpBook creates API documentation for a package dynamically
!

!PackageAPIHelpBook class methodsFor: 'instance creation' stamp: 'DannyChan 2/20/2010 11:15'!
on: aPackageString
	^self 
		titleBlock: [aPackageString]
		contentsBlock: [(aPackageString , ' - API Documentation') ]
		rootTopicsBlock: [(PackageInfo named: aPackageString) 
								classes collect: [:aClass | ClassAPIHelp on: aClass]].! !

!PackageAPIHelpBook methodsFor: 'testing' stamp: 'DannyChan 2/20/2010 10:40'!
isBook
	^true! !

!PackageAPIHelpBook methodsFor: 'testing' stamp: 'DannyChan 2/20/2010 10:40'!
isPage
	^self isBook not! !

HelpTopic subclass: #HelpBook
	instanceVariableNames: 'rootTopics'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!HelpBook methodsFor: 'accessing' stamp: 'tbn 2/12/2010 13:54'!
addTopic: aTopic
	self rootTopics add: aTopic! !

!HelpBook methodsFor: 'defaults' stamp: 'tbn 2/19/2010 15:44'!
defaultTitle
	^'Unnamed Book'
	! !

!HelpBook methodsFor: 'testing' stamp: 'tbn 2/12/2010 13:22'!
isBook
	^true! !

!HelpBook methodsFor: 'testing' stamp: 'tbn 2/12/2010 13:23'!
isPage
	^false! !

!HelpBook methodsFor: 'accessing' stamp: 'tbn 2/19/2010 15:48'!
label 
	^title ! !

!HelpBook methodsFor: 'accessing' stamp: 'tbn 2/12/2010 13:22'!
rootTopics 
	rootTopics isNil ifTrue: [rootTopics := OrderedCollection new].
	^rootTopics! !

HelpTopic subclass: #HelpPage
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'HelpSystem-Core-Model'!

!HelpPage methodsFor: 'defaults' stamp: 'tbn 2/19/2010 15:45'!
defaultTitle
	^'Unnamed Page'
	! !

!HelpTopic class methodsFor: 'instance creation' stamp: 'tbn 2/19/2010 15:47'!
named: aString
	^(self new)
		title: aString;
		yourself! !

!HelpTopic class methodsFor: 'instance creation' stamp: 'DannyChan 2/20/2010 09:15'!
title: aTitle contents: aText
	^(self new)
		title: aTitle;
		contents: aText;
		yourself.
		! !

!HelpTopic methodsFor: 'accessing' stamp: 'tbn 2/12/2010 15:17'!
contents
	^ contents! !

!HelpTopic methodsFor: 'accessing' stamp: 'tbn 2/12/2010 15:17'!
contents: anObject
	contents := anObject! !

!HelpTopic methodsFor: 'accessing' stamp: 'tbn 2/19/2010 15:44'!
defaultTitle
	^self subclassResponsibility 
	! !

!HelpTopic methodsFor: 'initialize-release' stamp: 'tbn 2/19/2010 15:44'!
initialize 
	super initialize.
	self title: self defaultTitle.
	self contents: ''
	! !

!HelpTopic methodsFor: 'testing' stamp: 'tbn 2/12/2010 13:21'!
isBook
	^false! !

!HelpTopic methodsFor: 'testing' stamp: 'tbn 2/12/2010 13:21'!
isPage
	^true! !

!HelpTopic methodsFor: 'accessing' stamp: 'tbn 2/12/2010 13:05'!
key 	
	^key! !

!HelpTopic methodsFor: 'accessing' stamp: 'tbn 2/12/2010 13:05'!
key: aUniqueKey
	key := aUniqueKey ! !

!HelpTopic methodsFor: 'accessing' stamp: 'tbn 2/19/2010 15:45'!
title
	^ title! !

!HelpTopic methodsFor: 'accessing' stamp: 'tbn 2/19/2010 15:45'!
title: anObject
	title := anObject! !
HelpBrowser initialize!
